#!/usr/bin/env python
#coding=utf8
"""
$Id: testThread.py,v 0.1 2014/05/15 09:09:30 alfille Exp $

Copyright (c) 2014 C-Bell (VAGor). All rights reserved.

Пример показывает, что опасно использовать консольный вывод в дочернем
потоке вкупе с вызовом sleep() в вызывающем потоке.

Чтобы понять разницу, нужно закомментировать вызов print(t) в
функции thr1().
"""

import threading, time

l1=[]
l2=[]
l3=[]

M=False

def thr1():
    while M:
        t=time.strftime("%Y.%m.%d %H:%M:%S")
        l1.append(t)
        #Если закомментировать вызов ниже, то l1 продолжит заполняться
        print (t)
        time.sleep(1)

def thr2():
    while M:
        l2.append(time.strftime("%Y.%m.%d %H:%M:%S"))
        time.sleep(2)

def thr3():
    while M:
        l3.append(time.strftime("%Y.%m.%d %H:%M:%S"))
        time.sleep(3)

def startThr():
    global M
    M=True
    t1=threading.Thread(target=thr1)
    t2=threading.Thread(target=thr2)
    t3=threading.Thread(target=thr3)
    t1.start()
    t2.start()
    t3.start()

def stopThr():
    global M
    M=False

def main():
    print ("Wait for 20 sec...")
    startThr()
    time.sleep(20)
    stopThr()
    print (l1)
    print ("")
    print (l2)
    print ("")
    print (l3)

if __name__=="__main__":
    main()
